#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>
#include <sdktools_entoutput>
#include <sdktools_entinput>

public Plugin:myinfo = 
{
	name	= "Destroyer Doors",
	author	= "wS / World-Source.Ru",
	version	= "1.1",
	url		= "http://world-source.ru/"
};

public OnPluginStart()
{
	HookEntityOutput("prop_door_rotating", "OnFullyOpen", Event_DoorOpen);
	HookEntityOutput("func_door", "OnFullyOpen", Event_DoorOpen);
	HookEntityOutput("func_door_rotating", "OnFullyOpen", Event_DoorOpen);
}

public Event_DoorOpen(const String:output[], door, activator, Float:delay)
{
	decl String:wS_Class[35];
	if (GetEntityClassname(door, wS_Class, 35) && StrContains(wS_Class, "func_") == -1)
	{
		new dissolver = CreateEntityByName("env_entity_dissolver");
		if (dissolver > 0)
		{
			DispatchKeyValue(door,			"targetname",	"wS_Door");
			DispatchKeyValue(dissolver, 	"target",		"wS_Door");
			DispatchKeyValue(dissolver,		"magnitude",	"1");
			DispatchKeyValue(dissolver,		"dissolvetype",	"0");
			AcceptEntityInput(dissolver,	"Dissolve");
			AcceptEntityInput(dissolver,	"Kill");
			return;
		}
	}
	AcceptEntityInput(door, "Kill");
}